* macros_conditional_processing.sps.

* This shows how to transform a number into a date:
  20011231 (form YMD) into the date 31 Dec 2001
  31122001 (form DMY) into the date 31 Dec 2001.

NEW FILE.
DATA LIST LIST /num1 num2.
BEGIN DATA
20011231 31122001
20020503  8022002
END DATA.

*//////////////.
DEFINE !datevar (form=!TOKENS(1) 	
	/num=!TOKENS(1) /newvar=!TOKENS(1))

!IF (!UPCASE(!form)=YMD) !THEN
COMPUTE #yr=TRUNC(!num/10000).
COMPUTE #mth=TRUNC(MOD(!num,10000)/100).
COMPUTE #day=MOD(!num,100).
PRINT /#yr #mth #day.

!ELSE !IF (!UPCASE(!form)=DMY) !THEN
STRING #datestr(A8).
COMPUTE #datestr=STRING(!num,F8).
COMPUTE #day=NUMBER(SUBSTR(#datestr,1,2),F4).
COMPUTE #mth=NUMBER(SUBSTR(#datestr,3,2),F4).
COMPUTE #yr=NUMBER(SUBSTR(#datestr,5),F4).
!IFEND
!IFEND

COMPUTE !newvar=DATE.DMY(#day,#mth,#yr).
FORMATS !newvar(DATE12).
VARIABLE WIDTH !newvar(11).
!ENDDEFINE.
*//////////////.

!datevar form=ymd num=num1 newvar=date1.
!datevar form=DMY num=num2 newvar=date2.

EXECUTE.
