* macros_examples_define_list_of_variables.

* This macro defines a macro which gives the list of all 
	variables between two given variables.
* The macro is useful when there are hundreds of variables.

SET MPRINT=no.
*///////////////////////////.
DEFINE !DefList (var1=!TOKENS(1) 
		/var2=!TOKENS(1) 
		/fname=!CMDEND)

GET FILE=!fname.
N OF CASES 1.
* Keep only the variables we need.
ADD FILES FILE=* /KEEP=!var1 TO !var2.
FLIP.

COMPUTE nobreak=1.
* Flag the first and last case.
MATCH FILES FILE=* /BY nobreak /FIRST=first /LAST=last.

* Write a macro which contains the variable names.
DO IF first.
- WRITE OUTFILE='c:\temp\list1.sps' / 'DEFINE !list1()' .
END IF.
WRITE OUTFILE='c:\temp\list1.sps' / " "case_lbl.
DO IF last.
WRITE OUTFILE='c:\temp\list1.sps' /' !ENDDEFINE.'.
END IF.
EXECUTE.

GET FILE=!fname.
* Define the macro.
INSERT FILE= 'c:\temp\list1.sps'.
!ENDDEFINE.
*/////// DefList /////////.


* Only 5 variables are used to illustrate the procedure.
DATA LIST LIST /id g x345 v3 k b.
BEGIN DATA.
1 1.21 3.01 5.51 41.98 12.2
2 2.33 5.67 4.22 6.02 13.4
END DATA.

SAVE OUTFILE='c:\temp\mydata.sav'.
EXECUTE.
SET MPRINT=yes.

* Call the macro.. 
!DefList var1=g var2=k fname="c:\temp\mydata.sav".
SET MPRINT=no.

