* use_variable_only_if_exists2.sps.

GET FILE='c:\program files\spss\employee data.sav'.

SET MPRINT=yes.

* General macro (would be in "define paths.sps" file).
DEFINE !vjobc(b=!TOKENS(1)/a=!TOKENS(1))
!IF(!EVAL(!jobc)="YES")!THEN 
!UNQUOTE(!b) jobcat !UNQUOTE(!a) 
!IFEND 
!ENDDEFINE.

DEFINE !jobc() YES !ENDDEFINE.

* Application.

SUMMARIZE
  /TABLES=educ !vjobc gender  
  /FORMAT=NOLIST TOTAL
  /TITLE='Jobcat exists (general macro)'
  /MISSING=VARIABLE
  /CELLS=COUNT .

* Custom Tables.
CTABLES
  /VLABELS VARIABLES=educ gender !vjobc DISPLAY=DEFAULT
  /TABLE educ [C][COUNT 'Count' F40.0] BY 
	gender [C] !vjobc b=" + " a=" [C]" /CATEGORIES VARIABLES=educ 
	gender !vjobc ORDER=A KEY=VALUE EMPTY=EXCLUDE
  /TITLES TITLE="Jobcat exists (general macro)".

* Example when variable not available.

DEFINE !jobc() NO !ENDDEFINE.
SUMMARIZE
  /TABLES=educ !vjobc gender  
  /FORMAT=NOLIST TOTAL
  /TITLE='Jobcat does not exist (gen. macro)'
  /MISSING=VARIABLE
  /CELLS=COUNT .

* Custom Tables.
CTABLES
  /VLABELS VARIABLES=educ gender !vjobc DISPLAY=DEFAULT
  /TABLE educ [C][COUNT 'Count' F40.0] BY 
	gender [C] !vjobc b=" + " a=" [C]" /CATEGORIES VARIABLES=educ 
	gender !vjobc ORDER=A KEY=VALUE EMPTY=EXCLUDE
  /TITLES TITLE="Jobcat does not exist (gen. macro)".
